# Ebin Shaders

This is a Minecraft shaderpack for use with [Optifine](http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1272953). Ebin is aiming to provide maximum performance, configurability, and visual quality. Whether you want to create easy scenic screenshots to post on reddit, film a complex Minecraft cinematic, or play on a competitive multiplayer server, Ebin is intended to accommodate all these situations, and more.

[Talk to us on Discord.](https://discord.gg/9YTc4Q4)

[Ebin has a website.](https://continuum.graphics/ebin/)

## Features
- Shadows / Shading - the basics
- Global Illumination
- Bloom / Glow
- Motion Blur
- Procedural 2D Clouds
- Procedural Water
- Screen Space Reflections
- Terrain Parallax - 3D blocks with a supported texture pack
- Multi-Layered Shading Pipeline - Everything is correctly shaded, even behind semi-transparent blocks
- Time Override - you can force it to be daytime on a multiplayer server
- Terrain Deformation - "Animal Crossing" and "Acid" deformations

## Requirements
- OptiFine 1.10.2 D1 or newer
- OpenGL 4.1 compatible hardware

## Installation

1. Download and install a compatible version of Optifine
2. Launch the game once to create the 'shaderpacks' folder, which is located with your "saves" folder
3. Make sure the Ebin-Shaders folder structure is correct if you're downloading from the GitHub repository
4. Place the Ebin-Shaders folder into your 'shaderpacks' folder.

### Folder Structure
It should be either:
>Ebin-Shaders/shaders/(.vsh & .fsh files)

or:
>Ebin-Shaders.zip/shaders/(.vsh & .fsh files)

If you download it from GitHub, it will be:
>Ebin-Shaders.zip/Ebin-Shaders/shaders/(.vsh & .fsh files)

## How to submit a crashlog
1. Make sure you're running the latest version of Ebin (don't send crashlogs from old versions).
2. Relaunch the game to clear any older crashlogs
3. From the main menu, select the copy of Ebin that is causing a crash
4. Log in to a singleplayer world
5. Close the game
6. The crashlog is located in either '/logs/shadersmod.log' OR '/logs/fml-client-latest.log'
7. Send us the crashlog on [Discord](https://discord.gg/9YTc4Q4)

## History

This shaderpack was created after spending years modifying other shaderpacks, primarily [SEUS](http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1280299). Ebin was created as a reaction to the many issues and inefficiencies within SEUS (which is by no means a bad shaderpack, it was probably the best shaderpack before the inception of Ebin). Developments within the Shaders Mod, such as its adoption by Optifine, and the addition of the #include preprocessor, boosted motivation to develop a more "modern" shaderpack.

## Team
- [BruceKnowsHow](https://github.com/BruceKnowsHow): Primary Developer
- [dotModded](https://github.com/dotModded): Co-Developer

## Contributors
[DethRaid](https://github.com/DethRaid), [zombye](https://github.com/zombye)


## Thanks
- [Sonic Ether](https://www.facebook.com/SonicEther/), creator of SEUS and inspiration for Ebin
- [daxnitro](http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1272365), original creator of the Shaders Mod
- [karyonix](http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1286604), longtime maintainer of the Shaders Mod
- [sp614x](https://twitter.com/sp614x), Ebin would not be possible without #include.
- [chocapic13](http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1293898) & [Sildur](http://www.minecraftforum.net/forums/mapping-and-modding/minecraft-mods/1291396), various code references and help over the years

![slide](https://raw.githubusercontent.com/wiki/BruceKnowsHow/Ebin-Shaders/images/cute-anime-bear.png)
